## prometheus-alertmanager 0.28.0+ds

=== debian/changelog ===
prometheus-alertmanager (0.28.0+ds-2) unstable; urgency=medium

  * Add new 0012-Default-to-legacy-label-name-validation-in-tests.patch to
    properly support building with an unpatched prometheus/common v0.62.0+

 -- Daniel Swarbrick <dswarbrick@debian.org>  Thu, 20 Feb 2025 01:13:29 +0000

prometheus-alertmanager (0.28.0+ds-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Drop obsolete 0009-Support-prometheus-common-v0.50.0.patch (implemented
    upstream)
  * Add new 0011-Disable-Jira-notification.patch
  * Add new Build-Depends:
    - golang-github-coder-quartz-dev
    - golang-github-emersion-go-sasl-dev
    - golang-github-emersion-go-smtp-dev
    - golang-github-kimmachinegun-automemlimit-dev
    - golang-uber-automaxprocs-dev
  * Drop obsolete Build-Depends:
    - golang-github-benbjohnson-clock-dev
    - golang-github-go-kit-log-dev
  * Bump golang-github-prometheus-exporter-toolkit-dev version constraint
    (>= 0.13.0)

 -- Daniel Swarbrick <dswarbrick@debian.org>  Tue, 11 Feb 2025 14:06:34 +0000

prometheus-alertmanager (0.27.0+ds-3) unstable; urgency=medium

  * Drop obsolete 0006-Revert-openapi-swaggerContext.patch
  * Bump golang-github-go-openapi-runtime-dev version constraint (>= 0.25.0~)
  * Add new 0010-Extend-testing-CA-certificates-expiry-date.patch
    (Closes: #1078634)
  * Bump Standards-Version to 4.7.0 (no changes)

 -- Daniel Swarbrick <dswarbrick@debian.org>  Sat, 30 Nov 2024 09:35:47 +0000

=== debian/control ===
Source: prometheus-alertmanager
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Martina Ferrari <tina@debian.org>,
           Daniel Swarbrick <dswarbrick@debian.org>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-bash-completion,
               dh-sequence-golang,
               golang-any,
               golang-github-alecthomas-units-dev,
               golang-github-aws-aws-sdk-go-dev,
               golang-github-cenkalti-backoff-dev (>= 4.0.0~),
               golang-github-cespare-xxhash-dev,
               golang-github-coder-quartz-dev,
               golang-github-emersion-go-sasl-dev,
               golang-github-emersion-go-smtp-dev,
               golang-github-go-openapi-analysis-dev,
               golang-github-go-openapi-errors-dev (>= 0.19.5~),
               golang-github-go-openapi-loads-dev,
               golang-github-go-openapi-runtime-dev (>= 0.25.0~),
               golang-github-go-openapi-spec-dev,
               golang-github-go-openapi-strfmt-dev (>= 0.19.0~),
               golang-github-go-openapi-swag-dev,
               golang-github-go-openapi-validate-dev (>= 0.20.3~),
               golang-github-gofrs-uuid-dev,
               golang-github-gogo-protobuf-dev,
               golang-github-hashicorp-go-sockaddr-dev,
               golang-github-hashicorp-golang-lru-v2-dev,
               golang-github-hashicorp-memberlist-dev,
               golang-github-jessevdk-go-flags-dev,
               golang-github-kimmachinegun-automemlimit-dev,
               golang-github-kylelemons-godebug-dev,
               golang-github-oklog-run-dev,
               golang-github-oklog-ulid-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-golang-dev (>= 1.19.0),
               golang-github-prometheus-common-dev (>= 0.33.0~),
               golang-github-prometheus-exporter-toolkit-dev (>= 0.13.0),
               golang-github-rs-cors-dev,
               golang-github-stretchr-testify-dev,
               golang-github-xlab-treeprint-dev (>= 0.0~git20180615),
               golang-go.uber-atomic-dev,
               golang-golang-x-mod-dev,
               golang-golang-x-net-dev,
               golang-golang-x-text-dev,
               golang-gopkg-alecthomas-kingpin.v2-dev,
               golang-gopkg-telebot.v3-dev,
               golang-gopkg-yaml.v2-dev,
               golang-protobuf-extensions-dev,
               golang-uber-automaxprocs-dev,
               tzdata,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/go-team/packages/prometheus-alertmanager
Vcs-Git: https://salsa.debian.org/go-team/packages/prometheus-alertmanager.git
Homepage: https://prometheus.io/
XS-Go-Import-Path: github.com/prometheus/alertmanager

Package: prometheus-alertmanager
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         tzdata,
         ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using},
Description: handle and deliver alerts created by Prometheus
 The Alertmanager handles alerts sent by client applications such as the
 Prometheus server. It takes care of deduplicating, grouping, and routing them
 to the correct receiver integration such as email, PagerDuty, or OpsGenie. It
 also takes care of silencing and inhibition of alerts.

Package: golang-github-prometheus-alertmanager-dev
Section: golang
Architecture: all
Multi-Arch: foreign
Depends: golang-github-alecthomas-units-dev,
         golang-github-aws-aws-sdk-go-dev,
         golang-github-cenkalti-backoff-dev (>= 4.0.0~),
         golang-github-cespare-xxhash-dev,
         golang-github-coder-quartz-dev,
         golang-github-emersion-go-sasl-dev,
         golang-github-emersion-go-smtp-dev,
         golang-github-go-openapi-analysis-dev,
         golang-github-go-openapi-errors-dev (>= 0.19.5~),
         golang-github-go-openapi-loads-dev,
         golang-github-go-openapi-runtime-dev (>= 0.25.0~),
         golang-github-go-openapi-spec-dev,
         golang-github-go-openapi-strfmt-dev (>= 0.19.0~),
         golang-github-go-openapi-swag-dev,
         golang-github-go-openapi-validate-dev (>= 0.20.3~),
         golang-github-gofrs-uuid-dev,
         golang-github-gogo-protobuf-dev,
         golang-github-hashicorp-go-sockaddr-dev,
         golang-github-hashicorp-golang-lru-v2-dev,
         golang-github-hashicorp-memberlist-dev,
         golang-github-jessevdk-go-flags-dev,
         golang-github-kimmachinegun-automemlimit-dev,
         golang-github-kylelemons-godebug-dev,
         golang-github-oklog-run-dev,
         golang-github-oklog-ulid-dev,
         golang-github-pkg-errors-dev,
         golang-github-prometheus-client-golang-dev (>= 1.19.0),
         golang-github-prometheus-common-dev (>= 0.33.0~),
         golang-github-prometheus-exporter-toolkit-dev (>= 0.13.0),
         golang-github-rs-cors-dev,
         golang-github-stretchr-testify-dev,
         golang-github-xlab-treeprint-dev (>= 0.0~git20180615),
         golang-go.uber-atomic-dev,
         golang-golang-x-mod-dev,
         golang-golang-x-net-dev,
         golang-golang-x-text-dev,
         golang-gopkg-alecthomas-kingpin.v2-dev,
         golang-gopkg-telebot.v3-dev,
         golang-gopkg-yaml.v2-dev,
         golang-protobuf-extensions-dev,
         golang-uber-automaxprocs-dev,
         tzdata,
         ${misc:Depends},
Description: handle and deliver alerts created by Prometheus -- source
 The Alertmanager handles alerts sent by client applications such as the
 Prometheus server. It takes care of deduplicating, grouping, and routing them
 to the correct receiver integration such as email, PagerDuty, or OpsGenie. It
 also takes care of silencing and inhibition of alerts.
 .
 This package provides the source code to be used as a library.

## prometheus-alertmanager 0.28.1~20250809125339.21%2Bbookworm

=== debian/changelog ===
prometheus-alertmanager (0.28.1~20250809125339.21+bookworm) stable; urgency=medium

  [ Mario Fetka ]
  * Bump
  * Bump

  [ root ]
  * bump

  [ jenkins-debian-glue Autobuilder ]
  * SNAPSHOT autobuild for unreleased 0.28.1 via jenkins-debian-glue.

 -- jenkins-debian-glue Autobuilder <jenkins@debdev.disconnected-by-peer.at>  Sat, 09 Aug 2025 14:53:39 +0200

prometheus-alertmanager (0.18.0) stable; urgency=medium

  * Version bump to 0.18.0.

 -- Jiri Tyr <jiri.tyr@gmail.com>  Mon, 12 Aug 2019 14:44:25 +0200

## prometheus-alertmanager 0.28.1~20250809125339.21%2Bbullseye

=== debian/changelog ===
prometheus-alertmanager (0.28.1~20250809125339.21+bullseye) stable; urgency=medium

  [ Mario Fetka ]
  * Bump
  * Bump

  [ root ]
  * bump

  [ jenkins-debian-glue Autobuilder ]
  * SNAPSHOT autobuild for unreleased 0.28.1 via jenkins-debian-glue.

 -- jenkins-debian-glue Autobuilder <jenkins@debdev.disconnected-by-peer.at>  Sat, 09 Aug 2025 14:53:39 +0200

## prometheus-alertmanager 0.28.1~20250809125400.21%2Bbuster

=== debian/changelog ===
prometheus-alertmanager (0.28.1~20250809125400.21+buster) stable; urgency=medium

  [ Mario Fetka ]
  * Bump
  * Bump

  [ root ]
  * bump

  [ jenkins-debian-glue Autobuilder ]
  * SNAPSHOT autobuild for unreleased 0.28.1 via jenkins-debian-glue.

 -- jenkins-debian-glue Autobuilder <jenkins@debdev.disconnected-by-peer.at>  Sat, 09 Aug 2025 14:54:00 +0200

## prometheus-alertmanager 0.28.1~20250809125400.21%2Btrixie

=== debian/changelog ===
prometheus-alertmanager (0.28.1~20250809125400.21+trixie) stable; urgency=medium

  [ Mario Fetka ]
  * Bump
  * Bump

  [ root ]
  * bump

  [ jenkins-debian-glue Autobuilder ]
  * SNAPSHOT autobuild for unreleased 0.28.1 via jenkins-debian-glue.

 -- jenkins-debian-glue Autobuilder <jenkins@debdev.disconnected-by-peer.at>  Sat, 09 Aug 2025 14:54:00 +0200

=== debian/control ===
Source: prometheus-alertmanager
Section: net
Priority: optional
Maintainer: Jiri Tyr <jiri.tyr@gmail.com>
Standards-Version: 4.1.1
Homepage: https://prometheus.io/

Package: prometheus-alertmanager
Architecture: any
Description: Alerts manager for the Prometheus server

=== debian/rules ===
#!/usr/bin/make -f

define checkdir
    @test -f debian/rules || \
    (echo Not in correct source directory; exit 1)
endef

define checkroot
    @test $$(id -u) = 0 || (echo need root priviledges; exit 1)
endef

PRODUCT = alertmanager
TOP_DIR := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)
SRC_DIR = $(TOP_DIR)
DEB_DIR = $(TOP_DIR)/debian
DEST_DIR = $(DEB_DIR)/$(PRODUCT)

BIN_DIR = $(DEST_DIR)/usr/bin
CONF_DIR = $(DEST_DIR)/etc/prometheus
DEFAULT_DIR = $(DEST_DIR)/etc/default
DOCS_DIR = $(DEST_DIR)/usr/share/doc/$(PRODUCT)
SYSD_DIR = $(DEST_DIR)/usr/lib/systemd/system

build:

binary:
	$(checkdir)
#	$(checkroot)
	mkdir -p $(DEST_DIR)/DEBIAN $(BIN_DIR) $(CONF_DIR) $(DEFAULT_DIR) $(DOCS_DIR) $(SYSD_DIR)
	install -Dm755 $(SRC_DIR)/$(PRODUCT) -t $(BIN_DIR)
	install -Dm755 $(SRC_DIR)/amtool -t $(BIN_DIR)
	install -Dm644 $(SRC_DIR)/LICENSE -t $(DOCS_DIR)
	install -Dm644 $(SRC_DIR)/NOTICE -t $(DOCS_DIR)
	install -Dm755 $(DEB_DIR)/postinst -t $(DEST_DIR)/DEBIAN
	install -Dm644 $(SRC_DIR)/$(PRODUCT).yml $(CONF_DIR)/$(PRODUCT).yml
	install -Dm644 $(DEB_DIR)/default $(DEFAULT_DIR)/$(PRODUCT)
	install -Dm644 $(DEB_DIR)/service $(SYSD_DIR)/$(PRODUCT).service
	dpkg-gencontrol -P$(DEST_DIR)
	cd $(DEST_DIR) && find . -type f ! -regex '.*DEBIAN/.*' -printf '%P\0' | xargs -r0 md5sum > DEBIAN/md5sums
	dpkg-deb -b $(DEST_DIR) ../

clean:
	$(checkdir)
	-rm -rf debian/$(PRODUCT)
	-rm -f debian/files
	-rm -f debian/substvars

.PHONY: binary clean

## prometheus-alertmanager 0.28.1%2Bds

=== template/Makefile ===
DOCKER_IMG := alertmanager-template
DOCKER_RUN_CURRENT_USER := docker run --user=$(shell id -u $(USER)):$(shell id -g $(USER))
DOCKER_CMD := $(DOCKER_RUN_CURRENT_USER) --rm -t -v $(PWD):/app -w /app $(DOCKER_IMG)

ifeq ($(NO_DOCKER), true)
	DOCKER_CMD=
endif

template-image:
	@(if [ "$(NO_DOCKER)" != "true" ] ; then \
		echo ">> build template docker image"; \
		docker build -t $(DOCKER_IMG) . > /dev/null; \
	fi; )

email.tmpl: template-image email.html
	@echo ">> inline css for html email template"
	$(DOCKER_CMD) ./inline-css.js

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/,\
      dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/prometheus/alertmanager/tags \
  (?:.*/)?v?(\d[\d\.]*(?:rc\d*)?)\.tar\.gz

## prometheus-alertmanager 0.28.1+ds

=== doc/alertmanager-mixin/Makefile ===
JSONNET_FMT := jsonnetfmt -n 2 --max-blank-lines 1 --string-style s --comment-style s
ALERTMANAGER_ALERTS := alertmanager_alerts.yaml

default: vendor build dashboards_out

all: fmt build

vendor: 
	jb install

fmt:
	find . -name 'vendor' -prune -o -name '*.libsonnet' -print -o -name '*.jsonnet' -print | \
		xargs -n 1 -- $(JSONNET_FMT) -i

lint: build
	find . -name 'vendor' -prune -o -name '*.libsonnet' -print -o -name '*.jsonnet' -print | \
		while read f; do \
			$(JSONNET_FMT) "$$f" | diff -u "$$f" -; \
		done

	mixtool lint mixin.libsonnet

dashboards_out: mixin.libsonnet config.libsonnet $(wildcard dashboards/*)
	@mkdir -p dashboards_out
	jsonnet -J vendor -m dashboards_out dashboards.jsonnet

build: vendor
	mixtool generate alerts mixin.libsonnet > $(ALERTMANAGER_ALERTS)

clean:
	rm -rf $(ALERTMANAGER_ALERTS)

=== examples/ha/tls/Makefile ===
# Based on https://github.com/wolfeidau/golang-massl/

.PHONY: start
start:
	goreman start

.PHONY: gen-certs
gen-certs: certs/ca.pem certs/node1.pem certs/node1-key.pem certs/node2.pem certs/node2-key.pem

certs/ca.pem certs/ca-key.pem: certs/ca-csr.json
	cd certs; cfssl gencert -initca ca-csr.json | cfssljson -bare ca

certs/node1.pem certs/node1-key.pem: certs/ca-config.json certs/ca.pem certs/ca-key.pem certs/node1-csr.json
	cd certs; cfssl gencert  \
    -ca=ca.pem \
    -ca-key=ca-key.pem \
    -config=ca-config.json \
    -hostname=localhost,127.0.0.1 \
    -profile=massl node1-csr.json | cfssljson -bare node1

certs/node2.pem certs/node2-key.pem: certs/ca-config.json certs/ca.pem certs/ca-key.pem certs/node2-csr.json
	cd certs; cfssl gencert  \
    -ca=ca.pem \
    -ca-key=ca-key.pem \
    -config=ca-config.json \
    -hostname=localhost,127.0.0.1 \
    -profile=massl node2-csr.json | cfssljson -bare node2

=== debian/changelog ===
prometheus-alertmanager (0.28.1+ds-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Add new Build-Depends golang-github-prometheus-sigv4-dev
  * Bump Standards-Version to 4.7.2 (no changes)
  * d/rules: add notify/opsgenie/api_key_file to DH_GOLANG_INSTALL_EXTRA,
    which is required by a test
  * Refresh packaging according to latest dh-make-golang template

 -- Daniel Swarbrick <dswarbrick@debian.org>  Sun, 09 Mar 2025 13:50:43 +0000

=== debian/control ===
Source: prometheus-alertmanager
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Martina Ferrari <tina@debian.org>,
           Daniel Swarbrick <dswarbrick@debian.org>,
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-sequence-bash-completion,
               dh-sequence-golang,
               golang-any,
               golang-github-alecthomas-units-dev,
               golang-github-aws-aws-sdk-go-dev,
               golang-github-cenkalti-backoff-dev (>= 4.0.0~),
               golang-github-cespare-xxhash-dev,
               golang-github-coder-quartz-dev,
               golang-github-emersion-go-sasl-dev,
               golang-github-emersion-go-smtp-dev,
               golang-github-go-openapi-analysis-dev,
               golang-github-go-openapi-errors-dev (>= 0.19.5~),
               golang-github-go-openapi-loads-dev,
               golang-github-go-openapi-runtime-dev (>= 0.25.0~),
               golang-github-go-openapi-spec-dev,
               golang-github-go-openapi-strfmt-dev (>= 0.19.0~),
               golang-github-go-openapi-swag-dev,
               golang-github-go-openapi-validate-dev (>= 0.20.3~),
               golang-github-gofrs-uuid-dev,
               golang-github-gogo-protobuf-dev,
               golang-github-hashicorp-go-sockaddr-dev,
               golang-github-hashicorp-golang-lru-v2-dev,
               golang-github-hashicorp-memberlist-dev,
               golang-github-jessevdk-go-flags-dev,
               golang-github-kimmachinegun-automemlimit-dev,
               golang-github-kylelemons-godebug-dev,
               golang-github-oklog-run-dev,
               golang-github-oklog-ulid-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-golang-dev (>= 1.19.0),
               golang-github-prometheus-common-dev (>= 0.33.0~),
               golang-github-prometheus-exporter-toolkit-dev (>= 0.13.0),
               golang-github-prometheus-sigv4-dev,
               golang-github-rs-cors-dev,
               golang-github-stretchr-testify-dev,
               golang-github-xlab-treeprint-dev (>= 0.0~git20180615),
               golang-go.uber-atomic-dev,
               golang-golang-x-mod-dev,
               golang-golang-x-net-dev,
               golang-golang-x-text-dev,
               golang-gopkg-alecthomas-kingpin.v2-dev,
               golang-gopkg-telebot.v3-dev,
               golang-gopkg-yaml.v2-dev,
               golang-protobuf-extensions-dev,
               golang-uber-automaxprocs-dev,
               tzdata,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/prometheus-alertmanager
Vcs-Git: https://salsa.debian.org/go-team/packages/prometheus-alertmanager.git
Homepage: https://github.com/prometheus/alertmanager
XS-Go-Import-Path: github.com/prometheus/alertmanager

Package: prometheus-alertmanager
Section: net
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         tzdata,
         ${misc:Depends},
         ${shlibs:Depends},
Static-Built-Using: ${misc:Static-Built-Using}
Description: handle and deliver alerts created by Prometheus
 The Alertmanager handles alerts sent by client applications such as the
 Prometheus server. It takes care of deduplicating, grouping, and routing them
 to the correct receiver integration such as email, PagerDuty, or OpsGenie. It
 also takes care of silencing and inhibition of alerts.

Package: golang-github-prometheus-alertmanager-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-github-alecthomas-units-dev,
         golang-github-aws-aws-sdk-go-dev,
         golang-github-cenkalti-backoff-dev (>= 4.0.0~),
         golang-github-cespare-xxhash-dev,
         golang-github-coder-quartz-dev,
         golang-github-emersion-go-sasl-dev,
         golang-github-emersion-go-smtp-dev,
         golang-github-go-openapi-analysis-dev,
         golang-github-go-openapi-errors-dev (>= 0.19.5~),
         golang-github-go-openapi-loads-dev,
         golang-github-go-openapi-runtime-dev (>= 0.25.0~),
         golang-github-go-openapi-spec-dev,
         golang-github-go-openapi-strfmt-dev (>= 0.19.0~),
         golang-github-go-openapi-swag-dev,
         golang-github-go-openapi-validate-dev (>= 0.20.3~),
         golang-github-gofrs-uuid-dev,
         golang-github-gogo-protobuf-dev,
         golang-github-hashicorp-go-sockaddr-dev,
         golang-github-hashicorp-golang-lru-v2-dev,
         golang-github-hashicorp-memberlist-dev,
         golang-github-jessevdk-go-flags-dev,
         golang-github-kimmachinegun-automemlimit-dev,
         golang-github-kylelemons-godebug-dev,
         golang-github-oklog-run-dev,
         golang-github-oklog-ulid-dev,
         golang-github-pkg-errors-dev,
         golang-github-prometheus-client-golang-dev (>= 1.19.0),
         golang-github-prometheus-common-dev (>= 0.33.0~),
         golang-github-prometheus-exporter-toolkit-dev (>= 0.13.0),
         golang-github-prometheus-sigv4-dev,
         golang-github-rs-cors-dev,
         golang-github-stretchr-testify-dev,
         golang-github-xlab-treeprint-dev (>= 0.0~git20180615),
         golang-go.uber-atomic-dev,
         golang-golang-x-mod-dev,
         golang-golang-x-net-dev,
         golang-golang-x-text-dev,
         golang-gopkg-alecthomas-kingpin.v2-dev,
         golang-gopkg-telebot.v3-dev,
         golang-gopkg-yaml.v2-dev,
         golang-protobuf-extensions-dev,
         golang-uber-automaxprocs-dev,
         tzdata,
         ${misc:Depends},
Description: handle and deliver alerts created by Prometheus -- source
 The Alertmanager handles alerts sent by client applications such as the
 Prometheus server. It takes care of deduplicating, grouping, and routing them
 to the correct receiver integration such as email, PagerDuty, or OpsGenie. It
 also takes care of silencing and inhibition of alerts.
 .
 This package provides the source code to be used as a library.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to enable verbose mode.
#export DH_VERBOSE := 1

# Acceptance tests need to be run separately.
export DH_GOPKG := github.com/prometheus/alertmanager
export DH_GOLANG_EXCLUDES := asset examples notify/jira test/.*/acceptance ui/react-app
export DH_GOLANG_EXCLUDES_ALL := 0
export DH_GOLANG_INSTALL_EXTRA := notify/opsgenie/api_key_file template/default.tmpl template/email.tmpl ui/app

METAPKG := github.com/prometheus/common

BRANCH     := debian/sid
USER       := team+pkg-go@tracker.debian.org
BUILD_DATE := $(shell date --utc --date='@$(SOURCE_DATE_EPOCH)' \
    +%Y%m%d-%H:%M:%S)
GO_VERSION := $(shell go version | sed 's/go version \(\S*\).*/\1/')
BUILDFLAGS  = -ldflags \
  " -X $(METAPKG)/version.Version=$(DEB_VERSION_UPSTREAM)\
    -X $(METAPKG)/version.Revision=$(DEB_VERSION)\
    -X $(METAPKG)/version.Branch=$(BRANCH)\
    -X $(METAPKG)/version.BuildUser=$(USER)\
    -X $(METAPKG)/version.BuildDate=$(BUILD_DATE)\
    -X $(METAPKG)/version.GoVersion=$(GO_VERSION)"

%:
	dh $@ --builddir=_build --buildsystem=golang

MANAGER_BINNAME := $(DEB_SOURCE)
TOOL_BINNAME := amtool

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)
	# Rename the binary to match the debian package.
	mv -v _build/bin/alertmanager _build/bin/$(MANAGER_BINNAME)
	# Build bash completion scripts.
	mkdir -vp _build/bash_completion.d
	_build/bin/$(TOOL_BINNAME) --completion-script-bash > _build/bash_completion.d/$(TOOL_BINNAME)

MAN_WHATIS_MANAGER := $(MANAGER_BINNAME) \\- the Prometheus alert manager
MAN_WHATIS_TOOL := $(TOOL_BINNAME) \\- Tooling for the Prometheus alert manager
MAN_PROG_MANAGER := $(shell echo $(MANAGER_BINNAME) | tr [:lower:] [:upper:])
MAN_PROG_TOOL := $(shell echo $(TOOL_BINNAME) | tr [:lower:] [:upper:])
MAN_DATE := $(shell date --utc --date='@$(SOURCE_DATE_EPOCH)' '+%B %Y')

execute_before_dh_installman:
	_build/bin/$(MANAGER_BINNAME) --help-man > _build/$(MANAGER_BINNAME).1
	_build/bin/$(TOOL_BINNAME) --help-man > _build/$(TOOL_BINNAME).1
	# Fix title header and footers.
	sed -i '/^.TH .*/c.TH $(MAN_PROG_MANAGER) "1" "$(MAN_DATE)" "$(DEB_SOURCE) $(DEB_VERSION_UPSTREAM)" "Prometheus"/' \
        _build/$(MANAGER_BINNAME).1
	sed -i '/^.TH .*/c.TH $(MAN_PROG_TOOL) "1" "$(MAN_DATE)" "$(DEB_SOURCE) $(DEB_VERSION_UPSTREAM)" "Prometheus"/' \
        _build/$(TOOL_BINNAME).1
	# Remove build user/build date/go version headers, which is ugly.
	sed -i '/^  /d' _build/*.1
	# Fix whatis entries.
	sed -i '/^.SH "NAME"/,+1c.SH "NAME"\n$(MAN_WHATIS_MANAGER)' _build/$(MANAGER_BINNAME).1
	sed -i '/^.SH "NAME"/,+1c.SH "NAME"\n$(MAN_WHATIS_TOOL)' _build/$(TOOL_BINNAME).1
	# Remove default values, as they create unwieldy long lines.
	sed -i 's/\\fB--\(.*\)=".*"\\fR/\\fB--\1\\fR/' _build/*.1
	# Fix executable path in amtool examples
	sed -i 's/\.\/amtool/amtool/' _build/$(TOOL_BINNAME).1

execute_after_dh_auto_test:
	# Don't abort if acceptance tests fail, as they are too sensitive to
	# timing issues.
	( for pkg in cli/acceptance with_api_v1/acceptance \
	    with_api_v2/acceptance; do \
	    DH_GOLANG_EXCLUDES= DH_GOPKG=$(DH_GOPKG)/test/$$pkg \
	    dh_auto_test || { \
		echo "*** Acceptance tests failed ***"; \
		exit 1; \
		}; \
	  done; ) || true
